#ifndef NOTEPAD_H
#define NOTEPAD_H

#include "doctab.h"
#include "savedialog.h"
#include <QMainWindow>
#include <QtWidgets>

class NotePad : public QMainWindow
{
    Q_OBJECT
private:    //fields

    QTabWidget* f_tabWid;
    unsigned int f_newTabsCount;
    QSignalMapper* f_sigMapper;
    QDockWidget* f_dockFileSysWid;
    QDockWidget* f_dockTabsWid;
    QTreeView* f_treeFileSysView;
    QListView* f_tableTabsView;
    QFileSystemModel* f_sysModel;
    QStringListModel* f_strListModel;
    QStringList f_openedTabsNames;
    QStringList f_openedTabsDirectories;
    QStringList f_codeExtensions;
    QString f_newTabName;
    int f_amountOfChanged;


private:    //methods

    DocTab* createNewDocument();
    void closeEvent(QCloseEvent *event);
    void getExtensionsFromIni();

public:     //methods
    NotePad(QWidget *parent = nullptr);
    ~NotePad();

public slots:
    void sltNewDocument();
    void sltOpen();
    void sltOpenIdx(const QModelIndex&);
    void sltSave();
    void sltSaveAs();
    void sltSaveAll();
    void sltClose();
    void sltCloseIdx(int);
    bool sltCloseAll();

    void sltChangeTabTitle(const QString&, const QString&);

    void sltTabs() const;
    void sltSetActiveTab(QWidget*);
    void sltSetActiveTab(const QModelIndex&);

    void sltFileBrowser() const;

    void sltOnClose();

    void sltCopy() const;
    void sltCut() const;
    void sltPaste() const;
    void sltDelete() const;
    void sltSelectAll() const;

    void sltFileChanged(const QString&);


};
#endif // NOTEPAD_H
